<?php
    namespace Folha\Logic\Cadastros\SetupOrganizacao;

    use Geral\Entities\Inscrestad;
    use HCM\Util\DateUtil;

    class CadastroInscesta{
        private $Cdempresa;
        private $Cdinscesta;
        private $Idtpijuriest;
        private $Nrinsjuriest;
        private $Cdpais;
        private $Sgestado;
        private $Cdmunicipio;
        private $Dsendeiest;
        private $Nmbairiest;
        private $Nrcepiest;
        private $Idtpimpresdanfe;
        private $Idtpambientenfe;
        private $Idapurlucpre;
        private $Nrorg;
        private $Dtinclusao;
        private $Idutserecfnf;
        private $Idutnrcupomnf;



        public function setCdempresa($Cdempresa)
        {
            $this->Cdempresa = $Cdempresa;
        }

        public function setCdinscesta($Cdinscesta)
        {
            $this->Cdinscesta = $Cdinscesta;
        }

        public function setCdmunicipio($Cdmunicipio)
        {
            $this->Cdmunicipio = $Cdmunicipio;
        }

        public function setCdpais($Cdpais)
        {
            $this->Cdpais = $Cdpais;
        }

        public function setIdtpimpresdanfe()
        {
            $this->Idtpimpresdanfe = 1;
        }

        public function setIdutnrcupomnf()
        {
            $this->Idutnrcupomnf = 'N';
        }

        public function setNrinsjuriest()
        {
            $this->Nrinsjuriest = 'ISENTA';
        }

        public function setNrorg($Nrorg)
        {
            $this->Nrorg = $Nrorg;
        }

        public function setSgestado($Sgestado)
        {
            $this->Sgestado = $Sgestado;
        }

        public function setIdutserecfnf()
        {
            $this->Idutserecfnf = 'N';
        }

        public function setNmbairiest()
        {
            $this->Nmbairiest = 'D';
        }

        public function setNrcepiest()
        {
            $this->Nrcepiest = 1;
        }

        public function setDsendeiest()
        {
            $this->Dsendeiest = 'D';
        }

        public function setDtinclusao()
        {
            $this->Dtinclusao = DateUtil::getDataAtual()->format(DateUtil::FORMATO_BRASILEIRO);
        }

        public function setIdapurlucpre()
        {
            $this->Idapurlucpre = 'N';
        }

        public function setIdtpambientenfe()
        {
            $this->Idtpambientenfe = 2;
        }

        public function setIdtpijuriest()
        {
            $this->Idtpijuriest = 'I';
        }

        public function __construct($Cdempresa, $Cdinscesta, $Cdmunicipio, $Cdpais, $Nrorg, $Sgestado){

            $this->setCdempresa($Cdempresa);
            $this->setCdinscesta($Cdinscesta);
            $this->setCdmunicipio($Cdmunicipio);
            $this->setIdapurlucpre();
            $this->setCdpais($Cdpais);
            $this->setIdtpimpresdanfe();
            $this->setIdutnrcupomnf();
            $this->setNrinsjuriest();
            $this->setNrorg($Nrorg);
            $this->setSgestado($Sgestado);
            $this->setIdutserecfnf();
            $this->setNmbairiest();
            $this->setNrcepiest();
            $this->setDsendeiest();
            $this->setDtinclusao();
            $this->setIdtpambientenfe();
            $this->setIdtpijuriest();

        }

        public function add(){

            $inscestadual = new \InscrestadEntity();

            $inscestadual->setCdempresa($this->Cdempresa);
            $inscestadual->setCdinscesta($this->Cdinscesta);
            $inscestadual->setCdmunicipio($this->Cdmunicipio);
            $inscestadual->setCdpais($this->Cdpais);
            $inscestadual->setIdtpimpresdanfe($this->Idtpimpresdanfe);
            $inscestadual->setIdutnrcupomnf($this->Idutnrcupomnf);
            $inscestadual->setNrinsjuriest($this->Nrinsjuriest);
            $inscestadual->setNrorg($this->Nrorg);
            $inscestadual->setSgestado($this->Sgestado);
            $inscestadual->setIdutserecfnf($this->Idutserecfnf);
            $inscestadual->setNmbairiest($this->Nmbairiest);
            $inscestadual->setNrcepiest($this->Nrcepiest);
            $inscestadual->setDsendeiest($this->Dsendeiest);
            $inscestadual->setDtinclusao($this->Dtinclusao);
            $inscestadual->setIdtpambientenfe($this->Idtpambientenfe);
            $inscestadual->setIdtpijuriest($this->Idtpijuriest);
            $inscestadual->setIdapurlucpre($this->Idapurlucpre);

            try {
                \Inscrestad::inserirInscrestad($inscestadual);
                return (true);
            } catch (\Exception $e) {
                tk_message($e->getMessage(), 'error');
            }
        }
        public static function Cadastrar($Cdempresa, $Cdinscesta, $Cdmunicipio, $Cdpais, $Nrorg, $Sgestado){
            $inscrestadual = new self($Cdempresa, $Cdinscesta, $Cdmunicipio, $Cdpais, $Nrorg, $Sgestado);
            return ($inscrestadual->add());
        }
    }